$CASE
$GENONLY
$DEBUG
$NOLOCALS
$CHECKCPU16
$CHECKBUS18
$NOMOD166			; disable the internal set of SAB 80C166 SFRs
$NOWARNING(120)
$NOWARNING(122)
@IF( ! @DEFINED(__STDNAMES ) )	
	$STDNAMES(reg166.def)	; use non-extended set of SFR's by default
@ELSE
	$STDNAMES(@__STDNAMES)	; use processor specific register definition 
@ENDI

$SEGMENTED

@DEFINE	EQUP	(pname,padr) @LOCAL(sss)
PUBLIC @pname
@sss	SECTION CODE AT @padr
@pname PROC FAR
@pname ENDP
@sss ENDS
@ENDD

@DEFINE	EQUB (bname,badr) @LOCAL(sss)
PUBLIC @bname
@sss	SECTION DATA AT @badr & 0FFFFFEh
	ORG	@badr
@bname LABEL BYTE
@sss ENDS
@ENDD

@DEFINE	EQUW (bname,badr) @LOCAL(sss)
PUBLIC @bname
@sss	SECTION DATA AT @badr
	ORG	@badr
@bname LABEL WORD
@sss ENDS
@ENDD

@EQUP(_doIDLE,0EE1CACh)
@EQUP(_GetKeyLockState1,0A34092h)
@EQUP(_turnLightON,0C0AF24h)

@EQUP(_pShowDialog,0D60340h)
@EQUP(_pDialogOnRun,0c40010h)
@EQUP(_doBack0A,0d63120h)
@EQUP(_DrawString,0D6A358h)
@EQUP(_FillRect,0C0E5D0h)
@EQUP(_OnTimer,0D6026Ch)
@EQUP(_OnTimer1,0F07FACh)
@EQUP(_OnTimer2,0F07EC0h)
@EQUP(_DisableTimer,0D60260h)

@EQUP(_drawImage,0D6A45Ch)

@EQUP(_AcquireGbsLock,0C1978Eh)
@EQUP(_FreeGbsLock,0C19798h)

@EQUP(_GBSS_po_open,0E49486h)
@EQUP(_GBSS_po_read,0E4952Eh)
@EQUP(_GBSS_po_close,0E497E0h)
@EQUP(_GBSS_po_write,0E49672h)

@EQUP(_FileOpen,0DFA73Eh)
@EQUP(_FileRead,0DFABAEh)
@EQUP(_FileWrite,0DFB0FEh)
@EQUP(_FileClose,0DFC570h)
@EQUP(_FileSeek,0DFB868h)

@EQUP(_FilesysICall,0E47FFCh)

@EQUP(_xsprintf,0A4884Eh)
@EQUP(_strlen,0C78536h)
@EQUP(_memset,0C78416h)
@EQUP(_memcpy,0C783B4h)
@EQUP(_memcpyW,0AABF1Ah)
@EQUP(_memcmp,0C78388h)


PUBLIC _FAM3_sig
_FAM3_sig_sss	SECTION CODE AT 0E47FFCh
_FAM3_sig LABEL WORD
_FAM3_sig_sss ENDS

PUBLIC __binfile
__binfile_sss	SECTION CODE AT 080000h
__binfile LABEL WORD
__binfile_sss ENDS

;@EQUB(_buf8k,082000h)

@EQUB(_keybQueneIdx,03B9B5h)
@EQUB(_keybQueneBuf,03B9B6h)
@EQUW(_GbsLock_ifNZ,03AF9Ch)
@EQUW(_GbsLock_ifZ,03AF96h)
@EQUW(_PidAct,03B1dch)

@EQUW(_AllHeapsPointers,039DCEh)
@EQUP(_FarMemAlloc,0C1A214h)
@EQUP(_FarMemFree,0C1A572h)
@EQUP(_HeapMalloc,0C1BCD8h)
@EQUP(_HeapFree,0C1BE78h)

;@EQUP(_GetVars,0E47D10h)
;@EQUP(_FreeVars,0E47D14h)

@EQUW(__hour,0365DEh)
@EQUW(__minute,0365DCh)
@EQUW(__day,0365E0h)
@EQUW(__month,0365E2h)
@EQUW(__year,0365E4h)

@EQUW(_NETMON_LAC,039D84h)
@EQUW(_NETMON_CI,039D86h)
@EQUW(_CELL6_PNT,0C9B96h)
@EQUW(_CURCELL_PNT,0C9B3Ah)
@EQUW(_NETMON7_TAB,039D8Ch)
@EQUP(_SetBAND,0A2C7FCh)
@EQUP(_GetRXLVL_by_CH,0CF3094h)

@EQUP(_STRtoWSTRP,0F19EA0h)
@EQUP(_DrawObject,0C1400Ah)
@EQUP(_PrepDrawObj_type02,0C14B14h)
@EQUP(_PrepDrawObj_type01,0C14A4Ch)

@EQUP(_DisplayMessageBoxV,0E6F138h)
@EQUP(_ResetStringID,0E65B5Eh)
@EQUP(_StoreTextAsAStringID,0E6599Ch)

NAME	XCSTART			; module name.
	
EXTERN	_main:FAR

PUBLIC __CSTART
__CSTART_MY	SECTION CODE WORD PUBLIC 'CMYINIT'
__CSTART 	PROC  FAR 
	jmps	_main
__CSTART	ENDP

__CSTART_MY	ENDS
END